//
//  ViewController.swift
//  AppnextMoPubAdapterSwiftTest
//
//  Created by Eran Mausner on 02/02/2016.
//  Copyright © 2016 Appnext. All rights reserved.
//

import UIKit

class ViewController: UIViewController, MPInterstitialAdControllerDelegate, MPRewardedVideoDelegate {

    static let kCustomEventInterstitialAdUnitID = "Your Ad Unit for Interstitial" // Your Ad Unit for Interstitial
    static let kCustomisedCustomEventInterstitialAdUnitID = "Your Ad Unit for Customised Interstitial" // Your Ad Unit for Customised Interstitial
    static let kCustomEventFullScreenAdUnitID = "Your Ad Unit for Full Screen Video" // Your Ad Unit for Full Screen Video
    static let kCustomisedCustomEventFullScreenAdUnitID = "Your Ad Unit for Customised Full Screen Video" // Your Ad Unit for Customised Full Screen Video
    static let kCustomEventRewardedAdUnitID = "Your Ad Unit for Rewarded Video" // Your Ad Unit for Rewarded Video
    static let kCustomisedCustomEventRewardedAdUnitID = "Your Ad Unit for Customised Rewarded Video" // Your Ad Unit for Customised Rewarded Video
    static let kRealRewardedAdUnitID = "Your Ad Unit for Real Rewarded Video" // Your Ad Unit for Real Rewarded Video

    @IBOutlet weak var label : UILabel?
    @IBOutlet weak var loadInterstitialButton : UIButton?
    @IBOutlet weak var showInterstitialButton : UIButton?
    @IBOutlet weak var loadCustomisedInterstitialButton : UIButton?
    @IBOutlet weak var showCustomisedInterstitialButton : UIButton?
    @IBOutlet weak var loadFullScreenButton : UIButton?
    @IBOutlet weak var showFullScreenButton : UIButton?
    @IBOutlet weak var loadCustomisedFullScreenButton : UIButton?
    @IBOutlet weak var showCustomisedFullScreenButton : UIButton?
    @IBOutlet weak var loadRewardedButton : UIButton?
    @IBOutlet weak var showRewardedButton : UIButton?
    @IBOutlet weak var loadCustomisedRewardedButton : UIButton?
    @IBOutlet weak var showCustomisedRewardedButton : UIButton?
    @IBOutlet weak var loadRealRewardedButton : UIButton?
    @IBOutlet weak var showRealRewardedButton : UIButton?

    var customEventInterstitial: MPInterstitialAdController?
    var customEventCustomisedInterstitial: MPInterstitialAdController?
    var customEventFullScreen: MPInterstitialAdController?
    var customEventCustomisedFullScreen: MPInterstitialAdController?
    var customEventRewarded: MPInterstitialAdController?
    var customEventCustomisedRewarded: MPInterstitialAdController?

    override func viewDidLoad() {
        super.viewDidLoad()
        self.showInterstitialButton!.hidden = true
        self.showCustomisedInterstitialButton!.hidden = true
        self.showFullScreenButton!.hidden = true
        self.showCustomisedFullScreenButton!.hidden = true
        self.showRewardedButton!.hidden = true
        self.showCustomisedRewardedButton!.hidden = true
        self.showRealRewardedButton!.hidden = true

        // Initialize rewarded video before loading any ads.
        MoPub.sharedInstance().initializeRewardedVideoWithGlobalMediationSettings(nil, delegate: self)
    }

    deinit {
        MoPub.sharedInstance().initializeRewardedVideoWithGlobalMediationSettings(nil, delegate: nil)
    }

    // MARK: - Actions

    @IBAction func loadInterstitial(sender: AnyObject) {
        if let interstitial = self.customEventInterstitial {
            interstitial.delegate = nil
            MPInterstitialAdController.removeSharedInterstitialAdController(self.customEventInterstitial)
            self.customEventInterstitial = nil
            self.showInterstitialButton?.hidden = true
        }

        self.customEventInterstitial = MPInterstitialAdController(forAdUnitId:ViewController.kCustomEventInterstitialAdUnitID)
        if let interstitial = self.customEventInterstitial {
            interstitial.delegate = self
            interstitial.loadAd()
        } else {
            self.label!.text = "ERROR Instantiating Interstitial"
        }
    }

    @IBAction func showInterstitial(sender: AnyObject) {
        if (self.customEventInterstitial?.ready == true) {
            self.customEventInterstitial?.showFromViewController(self)
        } else {
            // The interstitial wasn't ready, so continue as usual.
            self.label!.text = "Interstitial Not Ready"
        }
    }

    @IBAction func loadCustomisedInterstitial(sender: AnyObject) {
        if let interstitial = self.customEventCustomisedInterstitial {
            interstitial.delegate = nil
            MPInterstitialAdController.removeSharedInterstitialAdController(self.customEventCustomisedInterstitial)
            self.customEventCustomisedInterstitial = nil
            self.showCustomisedInterstitialButton?.hidden = true
        }

        self.customEventCustomisedInterstitial = MPInterstitialAdController(forAdUnitId:ViewController.kCustomisedCustomEventInterstitialAdUnitID)
        if let interstitial = self.customEventCustomisedInterstitial {
            interstitial.delegate = self
            interstitial.loadAd()
        } else {
            self.label!.text = "ERROR Instantiating Customised Interstitial"
        }
    }

    @IBAction func showCustomisedInterstitial(sender: AnyObject) {
        if (self.customEventCustomisedInterstitial?.ready == true) {
            self.customEventCustomisedInterstitial?.showFromViewController(self)
        } else {
            // The customised interstitial wasn't ready, so continue as usual.
            self.label!.text = "Customised Interstitial Not Ready"
        }
    }

    @IBAction func loadFullScreen(sender: AnyObject) {
        if let fullScreen = self.customEventFullScreen {
            fullScreen.delegate = nil
            MPInterstitialAdController.removeSharedInterstitialAdController(self.customEventFullScreen)
            self.customEventFullScreen = nil
            self.showFullScreenButton?.hidden = true
        }

        self.customEventFullScreen = MPInterstitialAdController(forAdUnitId:ViewController.kCustomEventFullScreenAdUnitID)
        if let fullScreen = self.customEventFullScreen {
            fullScreen.delegate = self
            fullScreen.loadAd()
        } else {
            self.label!.text = "ERROR Instantiating FullScreen"
        }
    }

    @IBAction func showFullScreen(sender: AnyObject) {
        if (self.customEventFullScreen?.ready == true) {
            self.customEventFullScreen?.showFromViewController(self)
        } else {
            // The FullScreen wasn't ready, so continue as usual.
            self.label!.text = "FullScreen Not Ready"
        }
    }

    @IBAction func loadCustomisedFullScreen(sender: AnyObject) {
        if let fullScreen = self.customEventCustomisedFullScreen {
            fullScreen.delegate = nil
            MPInterstitialAdController.removeSharedInterstitialAdController(self.customEventCustomisedFullScreen)
            self.customEventCustomisedFullScreen = nil
            self.showCustomisedFullScreenButton?.hidden = true
        }
        
        self.customEventCustomisedFullScreen = MPInterstitialAdController(forAdUnitId:ViewController.kCustomisedCustomEventFullScreenAdUnitID)
        if let fullScreen = self.customEventCustomisedFullScreen {
            fullScreen.delegate = self
            fullScreen.loadAd()
        } else {
            self.label!.text = "ERROR Instantiating Customised FullScreen"
        }
    }

    @IBAction func showCustomisedFullScreen(sender: AnyObject) {
        if (self.customEventCustomisedFullScreen?.ready == true) {
            self.customEventCustomisedFullScreen?.showFromViewController(self)
        } else {
            // The customised FullScreen wasn't ready, so continue as usual.
            self.label!.text = "Customised FullScreen Not Ready"
        }
    }

    @IBAction func loadRewarded(sender: AnyObject) {
        if let rewarded = self.customEventRewarded {
            rewarded.delegate = nil
            MPInterstitialAdController.removeSharedInterstitialAdController(self.customEventRewarded)
            self.customEventRewarded = nil
            self.showRewardedButton?.hidden = true
        }

        self.customEventRewarded = MPInterstitialAdController(forAdUnitId:ViewController.kCustomEventRewardedAdUnitID)
        if let rewarded = self.customEventRewarded {
            rewarded.delegate = self
            rewarded.loadAd()
        } else {
            self.label!.text = "ERROR Instantiating Rewarded"
        }
    }

    @IBAction func showRewarded(sender: AnyObject) {
        if (self.customEventRewarded?.ready == true) {
            self.customEventRewarded?.showFromViewController(self)
        } else {
            // The Rewarded wasn't ready, so continue as usual.
            self.label!.text = "Rewarded Not Ready"
        }
    }

    @IBAction func loadCustomisedRewarded(sender: AnyObject) {
        if let rewarded = self.customEventCustomisedRewarded {
            rewarded.delegate = nil
            MPInterstitialAdController.removeSharedInterstitialAdController(self.customEventCustomisedRewarded)
            self.customEventCustomisedRewarded = nil
            self.showCustomisedRewardedButton?.hidden = true
        }
        
        self.customEventCustomisedRewarded = MPInterstitialAdController(forAdUnitId:ViewController.kCustomisedCustomEventRewardedAdUnitID)
        if let rewarded = self.customEventCustomisedRewarded {
            rewarded.delegate = self
            rewarded.loadAd()
        } else {
            self.label!.text = "ERROR Instantiating Customised Rewarded"
        }
    }

    @IBAction func showCustomisedRewarded(sender: AnyObject) {
        if (self.customEventCustomisedRewarded?.ready == true) {
            self.customEventCustomisedRewarded?.showFromViewController(self)
        } else {
            // The customised Rewarded wasn't ready, so continue as usual.
            self.label!.text = "Customised Rewarded Not Ready"
        }
    }

    @IBAction func loadRealRewarded(sender: AnyObject) {
        let appnextSettings = AppnextMoPubGlobalMediationSettings.init()
        appnextSettings.config = AppnextRewardedVideoAdConfiguration.init()
        appnextSettings.config.buttonText = "Test"
        MPRewardedVideo.loadRewardedVideoAdWithAdUnitID(ViewController.kRealRewardedAdUnitID, withMediationSettings: [appnextSettings])
    }

    @IBAction func showRealRewarded(sender: AnyObject) {
        if (MPRewardedVideo.hasAdAvailableForAdUnitID(ViewController.kRealRewardedAdUnitID)) {
            MPRewardedVideo.presentRewardedVideoAdForAdUnitID(ViewController.kRealRewardedAdUnitID, fromViewController: self)
        } else {
            // The real Rewarded wasn't ready, so continue as usual.
            self.label!.text = "Real Rewarded Not Ready"
        }
    }

    // MARK: - MPInterstitialAdControllerDelegate implementation

    func interstitialDidLoadAd(interstitial: MPInterstitialAdController!) {
        if (interstitial == self.customEventInterstitial) {
            self.label!.text = "Interstitial Did Load"
            self.showInterstitialButton?.hidden = false
        } else if (interstitial == self.customEventCustomisedInterstitial) {
            self.label!.text = "Customised Interstitial Did Load"
            self.showCustomisedInterstitialButton?.hidden = false
        } else if (interstitial == self.customEventFullScreen) {
            self.label!.text = "FullScreen Did Load"
            self.showFullScreenButton?.hidden = false
        } else if (interstitial == self.customEventCustomisedFullScreen) {
            self.label!.text = "Customised FullScreen Did Load"
            self.showCustomisedFullScreenButton?.hidden = false
        } else if (interstitial == self.customEventRewarded) {
            self.label!.text = "Rewarded Did Load"
            self.showRewardedButton?.hidden = false
        } else if (interstitial == self.customEventCustomisedRewarded) {
            self.label!.text = "Customised Rewarded Did Load"
            self.showCustomisedRewardedButton?.hidden = false
        }
    }

    func interstitialDidFailToLoadAd(interstitial: MPInterstitialAdController!) {
        if (interstitial == self.customEventInterstitial) {
            self.label!.text = "Interstitial Did Fail To Load"
            self.showInterstitialButton?.hidden = true
        } else if (interstitial == self.customEventCustomisedInterstitial) {
            self.label!.text = "Customised Interstitial Did Fail To Load"
            self.showCustomisedInterstitialButton?.hidden = true
        } else if (interstitial == self.customEventFullScreen) {
            self.label!.text = "FullScreen Did Fail To Load"
            self.showFullScreenButton?.hidden = true
        } else if (interstitial == self.customEventCustomisedFullScreen) {
            self.label!.text = "Customised FullScreen Did Fail To Load"
            self.showCustomisedFullScreenButton?.hidden = true
        } else if (interstitial == self.customEventRewarded) {
            self.label!.text = "Rewarded Did Fail To Load"
            self.showRewardedButton?.hidden = true
        } else if (interstitial == self.customEventCustomisedRewarded) {
            self.label!.text = "Customised Rewarded Did Fail To Load"
            self.showCustomisedRewardedButton?.hidden = true
        }
    }

    func interstitialWillAppear(interstitial: MPInterstitialAdController!) {
    }

    func interstitialDidAppear(interstitial: MPInterstitialAdController!) {
    }

    func interstitialWillDisappear(interstitial: MPInterstitialAdController!) {
        if (interstitial == self.customEventInterstitial) {
            self.showInterstitialButton?.hidden = true
        } else if (interstitial == self.customEventCustomisedInterstitial) {
            self.showCustomisedInterstitialButton?.hidden = true
        } else if (interstitial == self.customEventFullScreen) {
            self.showFullScreenButton?.hidden = true
        } else if (interstitial == self.customEventCustomisedFullScreen) {
            self.showCustomisedFullScreenButton?.hidden = true
        } else if (interstitial == self.customEventRewarded) {
            self.showRewardedButton?.hidden = true
        } else if (interstitial == self.customEventCustomisedRewarded) {
            self.showCustomisedRewardedButton?.hidden = true
        }
    }

    func interstitialDidDisappear(interstitial: MPInterstitialAdController!) {
        if (interstitial == self.customEventInterstitial) {
            self.showInterstitialButton?.hidden = true
        } else if (interstitial == self.customEventCustomisedInterstitial) {
            self.showCustomisedInterstitialButton?.hidden = true
        } else if (interstitial == self.customEventFullScreen) {
            self.showFullScreenButton?.hidden = true
        } else if (interstitial == self.customEventCustomisedFullScreen) {
            self.showCustomisedFullScreenButton?.hidden = true
        } else if (interstitial == self.customEventRewarded) {
            self.showRewardedButton?.hidden = true
        } else if (interstitial == self.customEventCustomisedRewarded) {
            self.showCustomisedRewardedButton?.hidden = true
        }
    }

    func interstitialDidExpire(interstitial: MPInterstitialAdController!) {
        if (interstitial == self.customEventInterstitial) {
            self.label!.text = "Interstitial Did Expire"
            self.showInterstitialButton?.hidden = true
        } else if (interstitial == self.customEventCustomisedInterstitial) {
            self.label!.text = "Customised Interstitial Did Expire"
            self.showCustomisedInterstitialButton?.hidden = true
        } else if (interstitial == self.customEventFullScreen) {
            self.label!.text = "FullScreen Did Expire"
            self.showFullScreenButton?.hidden = true
        } else if (interstitial == self.customEventCustomisedFullScreen) {
            self.label!.text = "Customised FullScreen Did Expire"
            self.showCustomisedFullScreenButton?.hidden = true
        } else if (interstitial == self.customEventRewarded) {
            self.label!.text = "Rewarded Did Expire"
            self.showRewardedButton?.hidden = true
        } else if (interstitial == self.customEventCustomisedRewarded) {
            self.label!.text = "Customised Rewarded Did Expire"
            self.showCustomisedRewardedButton?.hidden = true
        }
    }

    func interstitialDidReceiveTapEvent(interstitial: MPInterstitialAdController!) {
        if (interstitial == self.customEventInterstitial) {
            self.label!.text = "Interstitial Tapped"
        } else if (interstitial == self.customEventCustomisedInterstitial) {
            self.label!.text = "Customised Interstitial Tapped"
        } else if (interstitial == self.customEventFullScreen) {
            self.label!.text = "FullScreen Tapped"
        } else if (interstitial == self.customEventCustomisedFullScreen) {
            self.label!.text = "Customised FullScreen Tapped"
        } else if (interstitial == self.customEventRewarded) {
            self.label!.text = "Rewarded Tapped"
        } else if (interstitial == self.customEventCustomisedRewarded) {
            self.label!.text = "Customised Rewarded Tapped"
        }
    }

    // MARK: - MPRewardedVideoDelegate implementation

    func rewardedVideoAdDidLoadForAdUnitID(adUnitID: String!) {
        self.label!.text = "Real Rewarded Did Load"
        self.showRealRewardedButton?.hidden = false
    }

    func rewardedVideoAdDidFailToLoadForAdUnitID(adUnitID: String!, error: NSError!) {
        self.label!.text = "Real Rewarded Did Fail To Load " + error.description
        self.showRealRewardedButton?.hidden = true
    }

    func rewardedVideoAdDidExpireForAdUnitID(adUnitID: String!) {
        self.label!.text = "Real Rewarded Did Expire"
        self.showRealRewardedButton?.hidden = true
    }

    func rewardedVideoAdDidFailToPlayForAdUnitID(adUnitID: String!, error: NSError!) {
        self.label!.text = "Real Rewarded Did Fail To Play " + error.description
        self.showRealRewardedButton?.hidden = true
    }

    func rewardedVideoAdWillAppearForAdUnitID(adUnitID: String!) {
    }

    func rewardedVideoAdDidAppearForAdUnitID(adUnitID: String!) {
    }

    func rewardedVideoAdWillDisappearForAdUnitID(adUnitID: String!) {
        self.showRealRewardedButton?.hidden = true
    }

    func rewardedVideoAdDidDisappearForAdUnitID(adUnitID: String!) {
        self.showRealRewardedButton?.hidden = true
    }

    func rewardedVideoAdDidReceiveTapEventForAdUnitID(adUnitID: String!) {
        self.label!.text = "Real Rewarded Tapped"
    }

    func rewardedVideoAdWillLeaveApplicationForAdUnitID(adUnitID: String!) {
    }

    func rewardedVideoAdShouldRewardForAdUnitID(adUnitID: String!, reward: MPRewardedVideoReward!) {
        if (reward.amount.integerValue == kMPRewardedVideoRewardCurrencyAmountUnspecified) {
            self.label!.text = "Real Rewarded Rewarded User with undefined amount of " + reward.currencyType
        } else {
            self.label!.text = "Real Rewarded Rewarded User with " + reward.amount.stringValue + " " + reward.currencyType
        }
    }
}
